/* Modified mouse initialization to accomondate for

 * Intellimouse vertical wheel (scroll) 

 * by DGar 02/05/2014

 */



/*

 * an arduino sketch to interface with a ps/2 mouse.

 * Also uses serial protocol to talk back to the host

 * and report what it finds.

 */



/*

* Pin 4 is the mouse data pin, pin 3 is the clock pin
* Feel free to use whatever pins are convenient.

 */

#define MDATA 4

#define MCLK 3 

int led = 7;
int led2 = 6;
int led3 =9 ;
int led4 = 8;
int led5 = 10;
int led6 = 13;

int lockswitch = 11;

int witchbutton_on = 1;

int but1State = HIGH; 
int but2State = HIGH; 
int but3State = HIGH; 
int but4State = HIGH; 
int but5State = HIGH; 

int lockState = HIGH; 

int currentbut1State = LOW;
int currentbut2State = HIGH;
int currentbut3State = HIGH;
int currentbut4State = HIGH;
int currentbut5State = HIGH;

int currentlockState = HIGH;

int lockcounter = 1;
int notecountleft = 36;
int notecountright =38;
int noteleftoff = 36;
int noterightoff = 38;


/*

 * according to some code I saw, these functions will

 * correctly set the mouse clock and data pins for

 * various conditions.

 */

void gohi(int pin)

{

  pinMode(pin, INPUT);

  digitalWrite(pin, HIGH);

}



void golo(int pin)

{

  pinMode(pin, OUTPUT);

  digitalWrite(pin, LOW);

}



void mouse_write(char data)

{

  char i;

  char parity = 1;



  //  Serial.print("Sending ");

  //  Serial.print(data, HEX);

  //  Serial.print(" to mouse\n");

  //  Serial.print("RTS");

  /* put pins in output mode */

  gohi(MDATA);

  gohi(MCLK);

  delayMicroseconds(300);

  golo(MCLK);

  delayMicroseconds(300);

  golo(MDATA);

  delayMicroseconds(10);

  /* start bit */

  gohi(MCLK);

  /* wait for mouse to take control of clock); */

  while (digitalRead(MCLK) == HIGH)

    ;

  /* clock is low, and we are clear to send data */

  for (i=0; i < 8; i++) {

    if (data & 0x01) {

      gohi(MDATA);

    } 

    else {

      golo(MDATA);

    }

    /* wait for clock cycle */

    while (digitalRead(MCLK) == LOW)

      ;

    while (digitalRead(MCLK) == HIGH)

      ;

    parity = parity ^ (data & 0x01);

    data = data >> 1;

  }  

  /* parity */

  if (parity) {

    gohi(MDATA);

  } 

  else {

    golo(MDATA);

  }

  while (digitalRead(MCLK) == LOW)

    ;

  while (digitalRead(MCLK) == HIGH)

    ;

  /* stop bit */

  gohi(MDATA);

  delayMicroseconds(50);

  while (digitalRead(MCLK) == HIGH)

    ;

  /* wait for mouse to switch modes */

  while ((digitalRead(MCLK) == LOW) || (digitalRead(MDATA) == LOW))

    ;

  /* put a hold on the incoming data. */

  golo(MCLK);

  //  Serial.print("done.\n");

}



/*

 * Get a byte of data from the mouse

 */

char mouse_read(void)

{

  char data = 0x00;

  int i;

  char bit = 0x01;



  //  Serial.print("reading byte from mouse\n");

  /* start the clock */

  gohi(MCLK);

  gohi(MDATA);

  delayMicroseconds(50);

  while (digitalRead(MCLK) == HIGH)

    ;

  delayMicroseconds(5);  /* not sure why */

  while (digitalRead(MCLK) == LOW) /* eat start bit */

    ;

  for (i=0; i < 8; i++) {

    while (digitalRead(MCLK) == HIGH)

      ;

    if (digitalRead(MDATA) == HIGH) {

      data = data | bit;

    }

    while (digitalRead(MCLK) == LOW)

      ;

    bit = bit << 1;

  }

  /* eat parity bit, which we ignore */

  while (digitalRead(MCLK) == HIGH)

    ;

  while (digitalRead(MCLK) == LOW)

    ;

  /* eat stop bit */

  while (digitalRead(MCLK) == HIGH)

    ;

  while (digitalRead(MCLK) == LOW)

    ;

  /* put a hold on the incoming data. */

  golo(MCLK);

  //  Serial.print("Recvd data ");

  //  Serial.print(data, HEX);

  //  Serial.print(" from mouse\n");

  return data;

}



void mouse_init()

{ char mouseId;

   

  gohi(MCLK);

  gohi(MDATA);

  //  Serial.print("Sending reset to mouse\n");

  mouse_write(0xff);

  mouse_read();  /* ack byte */

  //  Serial.print("Read ack byte1\n");

  mouse_read();  /* blank */

  mouse_read();  /* blank */

  //  Serial.print("Setting sample rate 200\n");

  mouse_write(0xf3);  /* Set rate command */

  mouse_read();  /* ack */

  mouse_write(0xC8);  /* Set rate command */

  mouse_read();  /* ack */

  //  Serial.print("Setting sample rate 100\n");

  mouse_write(0xf3);  /* Set rate command */

  mouse_read();  /* ack */

  mouse_write(0x64);  /* Set rate command */

  mouse_read();  /* ack */

  //  Serial.print("Setting sample rate 80\n");

  mouse_write(0xf3);  /* Set rate command */

  mouse_read();  /* ack */

  mouse_write(0x50);  /* Set rate command */

  mouse_read();  /* ack */

  //  Serial.print("Read device type\n");

  mouse_write(0xf2);  /* Set rate command */

  mouse_read();  /* ack */

  mouse_read();  /* mouse id, if this value is 0x00 mouse is standard, if it is 0x03 mouse is Intellimouse */

  //  Serial.print("Setting wheel\n");

  mouse_write(0xe8);  /* Set wheel resolution */

  mouse_read();  /* ack */

  mouse_write(0x03);  /* 8 counts per mm */

  mouse_read();  /* ack */

  mouse_write(0xe6);  /* scaling 1:1 */

  mouse_read();  /* ack */

  mouse_write(0xf3);  /* Set sample rate */

  mouse_read();  /* ack */

  mouse_write(0x28);  /* Set sample rate */

  mouse_read();  /* ack */

  mouse_write(0xf4);  /* Enable device */

  mouse_read();  /* ack */



  //  Serial.print("Sending remote mode code\n");

  mouse_write(0xf0);  /* remote mode */

  mouse_read();  /* ack */

  //  Serial.print("Read ack byte2\n");

  delayMicroseconds(100);

}



void setup()

{

    pinMode(led, OUTPUT); 
       pinMode(led2, OUTPUT); 
          pinMode(led3, OUTPUT); 
           pinMode(led4, OUTPUT);  
                pinMode(led5, OUTPUT); 
                   pinMode(led6, OUTPUT);  
                      pinMode(lockswitch, INPUT); 
                      digitalWrite(lockswitch, HIGH); 


Serial.begin(31250);
//Serial.begin(9600);

  mouse_init();

}



/*

 * get a reading from the mouse and report it back to the

 * host via the serial line.

 */

void loop()

{

 
  
    char testbutton;
  
  char mstat;

  char mx;

  char my;

  char mz;



  /* get a reading from the mouse */

  mouse_write(0xeb);  /* give me data! */

  mouse_read();      /* ignore ack */

  mstat = mouse_read();

  mx = mouse_read();

  my = mouse_read();

  mz = mouse_read();
  //  testbutton = mouse_read();



  /* send the data back up */
/*
  Serial.print(mstat, HEX);

  Serial.print("\tX=");

  Serial.print(mx, DEC);

  Serial.print("\tY=");

  Serial.print(my, DEC);

  Serial.print("\tZ=");

  Serial.print(mz, DEC);

  Serial.println();  */
  
    //delay(10);  /* twiddle */
// BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS   BUTTON PRESSES IFS
// BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS   BUTTON PRESSES IFS
// BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS    BUTTON PRESSES IFS   BUTTON PRESSES IFS
  
  
  // SCROLL   SCROLL   SCROLL   SCROLL   SCROLL   SCROLL   SCROLL   SCROLL   SCROLL   SCROLL   
   if(mz == 0x1){
   digitalWrite(led, HIGH);}
   if(mz !=0x1){
   digitalWrite(led, LOW);}
   if(mz == -1){
   digitalWrite(led2, HIGH);}
   if(mz !=-1){
   digitalWrite(led2, LOW);}
   
    
    // CASES LEFT BUTTON CASES LEFT BUTTON CASES LEFT BUTTON CASES LEFT BUTTON CASES LEFT BUTTON CASES LEFT BUTTON 
  // ON
   if(mstat == 0x09){ // LEFT  only
   digitalWrite(led3, HIGH); }
   if(mstat == 0x0b){   // LEFT and RIGHT 
   digitalWrite(led3, HIGH); }
   if(mstat == 0x0D){   // LEFT and CENTER 
   digitalWrite(led3, HIGH); }
   if(mstat == 0x0F){   // LEFT and CENTER and RIGHT 
   digitalWrite(led3, HIGH); }
 
 // OFF  
   if(mstat==0x08 ){  // NO BUTTON
   digitalWrite(led3, LOW);}
   if(mstat==0x0A ){  // RIGHT
   digitalWrite(led3, LOW);}
   if(mstat==0x0C ){  // CENTER 
   digitalWrite(led3, LOW);}
   if(mstat==0x0E ){  // CENTER and RIGHT
   digitalWrite(led3, LOW);}


// CASES RIGHT BUTTON   CASES RIGHT BUTTON   CASES RIGHT BUTTON   CASES RIGHT BUTTON   CASES RIGHT BUTTON   
     if(mstat == 0x0A){        // RIGHT 
     digitalWrite(led4, HIGH);}
     if(mstat == 0x0b){        // RIGHT and LEFT
     digitalWrite(led4, HIGH);}
     if(mstat == 0x0E){        // RIGHT and CENTER 
     digitalWrite(led4, HIGH);}
     if(mstat == 0x0F){        // RIGHT and CENTER and LEFT 
     digitalWrite(led4, HIGH);}
      // OFF
     if(mstat==0x09 ){         // LEFT
     digitalWrite(led4, LOW);}
     if(mstat==0x08 ){         // NO BUTTON
     digitalWrite(led4, LOW);}
     if(mstat==0x0C ){         // CENTER
     digitalWrite(led4, LOW);}
     if(mstat==0x0D ){         // CENTER and LEFT
     digitalWrite(led4, LOW);}


// CASES CENTER  // CASES CENTER  // CASES CENTER  // CASES CENTER  // CASES CENTER  // CASES CENTER  // CASES CENTER  
   
     if(mstat == 0x0E){        // RIGHT and CENTER 
     digitalWrite(led5, HIGH);}
     if(mstat == 0x0F){        // RIGHT and CENTER and LEFT 
     digitalWrite(led5, HIGH);}
     if(mstat == 0x0C){        // CENTER 
     digitalWrite(led5, HIGH);}
     if(mstat == 0x0D){        //  CENTER and LEFT 
     digitalWrite(led5, HIGH);}
   // OFF
   
     if(mstat==0x09 ){         // LEFT
     digitalWrite(led5, LOW);}
     if(mstat==0x08 ){         // NO BUTTON
     digitalWrite(led5, LOW);}
     if(mstat == 0x0A){        // RIGHT 
     digitalWrite(led5, LOW); }
     if(mstat == 0x0b){        // RIGHT and LEFT
     digitalWrite(led5, LOW);}
   
     // STATUS LED    STATUS LED    STATUS LED    STATUS LED    STATUS LED    STATUS LED   
     
  if(lockState == LOW ) {
  digitalWrite(led6, HIGH);}

 if((mstat!=0x08 || (mz ==0x1) || (mz ==-1))  ) {
  digitalWrite(led6, HIGH);}
  
 if(mstat==0x08 && (mz !=0x1) && (mz !=-1)  && lockState == HIGH ){ 
  digitalWrite(led6, LOW);}
  
  // for note listen scroll
   if(mstat!=0x08 && ((mz ==0x1) || (mz ==-1))  && lockState == HIGH ) {
  digitalWrite(led6, LOW);
//delay (20);
}


// lockcounter   // lockcounter   // lockcounter   // lockcounter   // lockcounter   // lockcounter   // lockcounter   

 
 // lockcounter     // lockcounter     // lockcounter     // lockcounter     // lockcounter     // lockcounter    

 but1State = digitalRead(led3);                    // left mouse button // left mouse button // left mouse button // left mouse button // left mouse button 
 if( but1State == HIGH && currentbut1State == LOW  )
 {       Serial.write(144);                                                             
  Serial.write(notecountleft);
  Serial.write(126);  
 witchbutton_on = 1;
 noteleftoff = notecountleft; }
  if( but1State == LOW && currentbut1State == HIGH  )
 {    Serial.write(144);                                                             
  Serial.write(noteleftoff);
  Serial.write(0);  
// digitalWrite(led1, LOW);    
 }
currentbut1State = but1State ;
                                                 // right mouse button  // right mouse button  // right mouse button  // right mouse button  // right mouse button 

 but2State = digitalRead(led4); 
 if( but2State == HIGH && currentbut2State == LOW  )
 {       Serial.write(144);                                                             
  Serial.write(notecountright);
  Serial.write(126);  
  witchbutton_on = 2; 
noterightoff = notecountright;}
  if( but2State == LOW && currentbut2State == HIGH  )
 {    Serial.write(144);                                                             
  Serial.write(noterightoff);
  Serial.write(0);  
 
 }
 currentbut2State = but2State ;
 
  lockState = digitalRead(lockswitch);  
 but3State = digitalRead(led2);      //   up wheel     up wheel     up wheel     up wheel     up wheel     up wheel   
 if( but3State == HIGH && currentbut3State == LOW  &&  witchbutton_on == 1 && lockState == HIGH)
 {   notecountleft = notecountleft++  ;    }
  if( but3State == HIGH && currentbut3State == LOW  &&  witchbutton_on == 2 && lockState == HIGH)
 {   notecountright = notecountright++  ;    }
 if( notecountleft > 127 ){
  notecountleft = 127; }  
  if( notecountright > 127 ){
  notecountright = 127; }   
  
     if( but3State == HIGH && currentbut3State == LOW  &&   but1State == HIGH && but2State == LOW )    // scrolltrigger left up/// scrolltrigger left up/// scrolltrigger left up/
 {  
   Serial.write(144);                                                             
  Serial.write(noteleftoff);
  Serial.write(0); 
  
   Serial.write(144);                                                             
  Serial.write(notecountleft);
  Serial.write(126); 
 
 noteleftoff = notecountleft;
  }
  
  
     if( but3State == HIGH && currentbut3State == LOW  &&   but1State == LOW && but2State ==HIGH ) // scrolltrigger right up/// // scrolltrigger right up/// // scrolltrigger right up///  
 {  
   Serial.write(144);                                                             
  Serial.write(noterightoff);
  Serial.write(0); 
  
   Serial.write(144);                                                             
  Serial.write(notecountright);
  Serial.write(126); 
 
 noterightoff = notecountright;
  }
  
  
  if( but3State == LOW && currentbut3State == HIGH  )
 {     
 }
currentbut3State = but3State ;


 
 but4State = digitalRead(led);      //   up wheel     up wheel     up wheel     up wheel     up wheel     up wheel   
 if( but4State == HIGH && currentbut4State == LOW  &&  witchbutton_on == 1  && lockState == HIGH )
 {   notecountleft = notecountleft--  ;    }
  if( but4State == HIGH && currentbut4State == LOW  &&  witchbutton_on == 2  && lockState == HIGH )
 {   notecountright = notecountright--  ;    }
 if( notecountleft < 1 ){
  notecountleft = 1; } 
 if( notecountright < 1 ){
  notecountright = 1; }   
 
   if( but4State == HIGH && currentbut4State == LOW  &&   but1State == HIGH && but2State == LOW )    // scrolltrigger left down// scrolltrigger left down// scrolltrigger left down
 {  
   Serial.write(144);                                                             
  Serial.write(noteleftoff);
  Serial.write(0); 
  
   Serial.write(144);                                                             
  Serial.write(notecountleft);
  Serial.write(126); 
 
 noteleftoff = notecountleft;
  }
  
  
     if( but4State == HIGH && currentbut4State == LOW  &&   but1State == LOW && but2State ==HIGH ) // scrolltrigger right down/// scrolltrigger right down/// scrolltrigger right down/ 
 {  
   Serial.write(144);                                                             
  Serial.write(noterightoff);
  Serial.write(0); 
  
   Serial.write(144);                                                             
  Serial.write(notecountright);
  Serial.write(126); 
 
 noterightoff = notecountright;
  }
 
  if( but4State == LOW && currentbut4State == HIGH  )
 {     
 }
currentbut4State = but4State ;





}
